# This file is auto-generated by the CDP protocol generator.
# Do not edit this file manually as your changes will be overwritten.
# Generated from Chrome DevTools Protocol specifications.

"""CDP Accessibility Domain Types"""

from enum import Enum
from typing import Any, List, Optional
from typing_extensions import TypedDict

from typing import TYPE_CHECKING

if TYPE_CHECKING:
    from ..dom.types import BackendNodeId
    from ..page.types import FrameId

"""Unique accessibility node identifier."""
AXNodeId = str



"""Enum of possible property types."""
class AXValueType(Enum):
    BOOLEAN = "boolean"
    TRISTATE = "tristate"
    BOOLEANORUNDEFINED = "booleanOrUndefined"
    IDREF = "idref"
    IDREFLIST = "idrefList"
    INTEGER = "integer"
    NODE = "node"
    NODELIST = "nodeList"
    NUMBER = "number"
    STRING = "string"
    COMPUTEDSTRING = "computedString"
    TOKEN = "token"
    TOKENLIST = "tokenList"
    DOMRELATION = "domRelation"
    ROLE = "role"
    INTERNALROLE = "internalRole"
    VALUEUNDEFINED = "valueUndefined"



"""Enum of possible property sources."""
class AXValueSourceType(Enum):
    ATTRIBUTE = "attribute"
    IMPLICIT = "implicit"
    STYLE = "style"
    CONTENTS = "contents"
    PLACEHOLDER = "placeholder"
    RELATEDELEMENT = "relatedElement"



"""Enum of possible native property sources (as a subtype of a particular AXValueSourceType)."""
class AXValueNativeSourceType(Enum):
    DESCRIPTION = "description"
    FIGCAPTION = "figcaption"
    LABEL = "label"
    LABELFOR = "labelfor"
    LABELWRAPPED = "labelwrapped"
    LEGEND = "legend"
    RUBYANNOTATION = "rubyannotation"
    TABLECAPTION = "tablecaption"
    TITLE = "title"
    OTHER = "other"



"""A single source for a computed AX property."""
class AXValueSource(TypedDict):
    type: "AXValueSourceType"
    """What type of source this is."""
    value: "Optional[AXValue]"
    """The value of this property source."""
    attribute: "Optional[str]"
    """The name of the relevant attribute, if any."""
    attributeValue: "Optional[AXValue]"
    """The value of the relevant attribute, if any."""
    superseded: "Optional[bool]"
    """Whether this source is superseded by a higher priority source."""
    nativeSource: "Optional[AXValueNativeSourceType]"
    """The native markup source for this value, e.g. a `<label>` element."""
    nativeSourceValue: "Optional[AXValue]"
    """The value, such as a node or node list, of the native source."""
    invalid: "Optional[bool]"
    """Whether the value for this property is invalid."""
    invalidReason: "Optional[str]"
    """Reason for the value being invalid, if it is."""



class AXRelatedNode(TypedDict):
    backendDOMNodeId: "BackendNodeId"
    """The BackendNodeId of the related DOM node."""
    idref: "Optional[str]"
    """The IDRef value provided, if any."""
    text: "Optional[str]"
    """The text alternative of this node in the current context."""



class AXProperty(TypedDict):
    name: "AXPropertyName"
    """The name of this property."""
    value: "AXValue"
    """The value of this property."""



"""A single computed AX property."""
class AXValue(TypedDict):
    type: "AXValueType"
    """The type of this value."""
    value: "Optional[Any]"
    """The computed value of this property."""
    relatedNodes: "Optional[List[AXRelatedNode]]"
    """One or more related nodes, if applicable."""
    sources: "Optional[List[AXValueSource]]"
    """The sources which contributed to the computation of this property."""



"""Values of AXProperty name:
- from 'busy' to 'roledescription': states which apply to every AX node
- from 'live' to 'root': attributes which apply to nodes in live regions
- from 'autocomplete' to 'valuetext': attributes which apply to widgets
- from 'checked' to 'selected': states which apply to widgets
- from 'activedescendant' to 'owns' - relationships between elements other than parent/child/sibling."""
class AXPropertyName(Enum):
    ACTIONS = "actions"
    BUSY = "busy"
    DISABLED = "disabled"
    EDITABLE = "editable"
    FOCUSABLE = "focusable"
    FOCUSED = "focused"
    HIDDEN = "hidden"
    HIDDENROOT = "hiddenRoot"
    INVALID = "invalid"
    KEYSHORTCUTS = "keyshortcuts"
    SETTABLE = "settable"
    ROLEDESCRIPTION = "roledescription"
    LIVE = "live"
    ATOMIC = "atomic"
    RELEVANT = "relevant"
    ROOT = "root"
    AUTOCOMPLETE = "autocomplete"
    HASPOPUP = "hasPopup"
    LEVEL = "level"
    MULTISELECTABLE = "multiselectable"
    ORIENTATION = "orientation"
    MULTILINE = "multiline"
    READONLY = "readonly"
    REQUIRED = "required"
    VALUEMIN = "valuemin"
    VALUEMAX = "valuemax"
    VALUETEXT = "valuetext"
    CHECKED = "checked"
    EXPANDED = "expanded"
    MODAL = "modal"
    PRESSED = "pressed"
    SELECTED = "selected"
    ACTIVEDESCENDANT = "activedescendant"
    CONTROLS = "controls"
    DESCRIBEDBY = "describedby"
    DETAILS = "details"
    ERRORMESSAGE = "errormessage"
    FLOWTO = "flowto"
    LABELLEDBY = "labelledby"
    OWNS = "owns"
    URL = "url"



"""A node in the accessibility tree."""
class AXNode(TypedDict):
    nodeId: "AXNodeId"
    """Unique identifier for this node."""
    ignored: "bool"
    """Whether this node is ignored for accessibility"""
    ignoredReasons: "Optional[List[AXProperty]]"
    """Collection of reasons why this node is hidden."""
    role: "Optional[AXValue]"
    """This `Node`'s role, whether explicit or implicit."""
    chromeRole: "Optional[AXValue]"
    """This `Node`'s Chrome raw role."""
    name: "Optional[AXValue]"
    """The accessible name for this `Node`."""
    description: "Optional[AXValue]"
    """The accessible description for this `Node`."""
    value: "Optional[AXValue]"
    """The value for this `Node`."""
    properties: "Optional[List[AXProperty]]"
    """All other properties"""
    parentId: "Optional[AXNodeId]"
    """ID for this node's parent."""
    childIds: "Optional[List[AXNodeId]]"
    """IDs for each of this node's child nodes."""
    backendDOMNodeId: "Optional[BackendNodeId]"
    """The backend ID for the associated DOM node, if any."""
    frameId: "Optional[FrameId]"
    """The frame ID for the frame associated with this nodes document."""
