# This file is auto-generated by the CDP protocol generator.
# Do not edit this file manually as your changes will be overwritten.
# Generated from Chrome DevTools Protocol specifications.

"""CDP BackgroundService Domain Types"""

from enum import Enum
from typing import List
from typing_extensions import TypedDict

from typing import TYPE_CHECKING

if TYPE_CHECKING:
    from ..network.types import TimeSinceEpoch
    from ..serviceworker.types import RegistrationID

"""The Background Service that will be associated with the commands/events.
Every Background Service operates independently, but they share the same
API."""
class ServiceName(Enum):
    BACKGROUNDFETCH = "backgroundFetch"
    BACKGROUNDSYNC = "backgroundSync"
    PUSHMESSAGING = "pushMessaging"
    NOTIFICATIONS = "notifications"
    PAYMENTHANDLER = "paymentHandler"
    PERIODICBACKGROUNDSYNC = "periodicBackgroundSync"



"""A key-value pair for additional event information to pass along."""
class EventMetadata(TypedDict):
    key: "str"
    value: "str"



class BackgroundServiceEvent(TypedDict):
    timestamp: "TimeSinceEpoch"
    """Timestamp of the event (in seconds)."""
    origin: "str"
    """The origin this event belongs to."""
    serviceWorkerRegistrationId: "RegistrationID"
    """The Service Worker ID that initiated the event."""
    service: "ServiceName"
    """The Background Service this event belongs to."""
    eventName: "str"
    """A description of the event."""
    instanceId: "str"
    """An identifier that groups related events together."""
    eventMetadata: "List[EventMetadata]"
    """A list of event-specific information."""
    storageKey: "str"
    """Storage key this event belongs to."""
