# This file is auto-generated by the CDP protocol generator.
# Do not edit this file manually as your changes will be overwritten.
# Generated from Chrome DevTools Protocol specifications.

"""CDP CacheStorage Domain Types"""

from enum import Enum
from typing import List, Optional
from typing_extensions import TypedDict

from typing import TYPE_CHECKING

if TYPE_CHECKING:
    from ..storage.types import StorageBucket

"""Unique identifier of the Cache object."""
CacheId = str



"""type of HTTP response cached"""
class CachedResponseType(Enum):
    BASIC = "basic"
    CORS = "cors"
    DEFAULT = "default"
    ERROR = "error"
    OPAQUERESPONSE = "opaqueResponse"
    OPAQUEREDIRECT = "opaqueRedirect"



"""Data entry."""
class DataEntry(TypedDict):
    requestURL: "str"
    """Request URL."""
    requestMethod: "str"
    """Request method."""
    requestHeaders: "List[Header]"
    """Request headers"""
    responseTime: "float"
    """Number of seconds since epoch."""
    responseStatus: "int"
    """HTTP response status code."""
    responseStatusText: "str"
    """HTTP response status text."""
    responseType: "CachedResponseType"
    """HTTP response type"""
    responseHeaders: "List[Header]"
    """Response headers"""



"""Cache identifier."""
class Cache(TypedDict):
    cacheId: "CacheId"
    """An opaque unique id of the cache."""
    securityOrigin: "str"
    """Security origin of the cache."""
    storageKey: "str"
    """Storage key of the cache."""
    storageBucket: "Optional[StorageBucket]"
    """Storage bucket of the cache."""
    cacheName: "str"
    """The name of the cache."""



class Header(TypedDict):
    name: "str"
    value: "str"



"""Cached response"""
class CachedResponse(TypedDict):
    body: "str"
    """Entry content, base64-encoded. (Encoded as a base64 string when passed over JSON)"""
