# This file is auto-generated by the CDP protocol generator.
# Do not edit this file manually as your changes will be overwritten.
# Generated from Chrome DevTools Protocol specifications.

"""CDP DOMSnapshot Domain Types"""

from typing import List, Optional
from typing_extensions import TypedDict

from typing import TYPE_CHECKING

if TYPE_CHECKING:
    from ..dom.types import BackendNodeId
    from ..dom.types import PseudoType
    from ..dom.types import Rect
    from ..dom.types import ShadowRootType
    from ..domdebugger.types import EventListener
    from ..page.types import FrameId

"""A Node in the DOM tree."""
class DOMNode(TypedDict):
    nodeType: "int"
    """`Node`'s nodeType."""
    nodeName: "str"
    """`Node`'s nodeName."""
    nodeValue: "str"
    """`Node`'s nodeValue."""
    textValue: "Optional[str]"
    """Only set for textarea elements, contains the text value."""
    inputValue: "Optional[str]"
    """Only set for input elements, contains the input's associated text value."""
    inputChecked: "Optional[bool]"
    """Only set for radio and checkbox input elements, indicates if the element has been checked"""
    optionSelected: "Optional[bool]"
    """Only set for option elements, indicates if the element has been selected"""
    backendNodeId: "BackendNodeId"
    """`Node`'s id, corresponds to DOM.Node.backendNodeId."""
    childNodeIndexes: "Optional[List[int]]"
    """The indexes of the node's child nodes in the `domNodes` array returned by `getSnapshot`, if
any."""
    attributes: "Optional[List[NameValue]]"
    """Attributes of an `Element` node."""
    pseudoElementIndexes: "Optional[List[int]]"
    """Indexes of pseudo elements associated with this node in the `domNodes` array returned by
`getSnapshot`, if any."""
    layoutNodeIndex: "Optional[int]"
    """The index of the node's related layout tree node in the `layoutTreeNodes` array returned by
`getSnapshot`, if any."""
    documentURL: "Optional[str]"
    """Document URL that `Document` or `FrameOwner` node points to."""
    baseURL: "Optional[str]"
    """Base URL that `Document` or `FrameOwner` node uses for URL completion."""
    contentLanguage: "Optional[str]"
    """Only set for documents, contains the document's content language."""
    documentEncoding: "Optional[str]"
    """Only set for documents, contains the document's character set encoding."""
    publicId: "Optional[str]"
    """`DocumentType` node's publicId."""
    systemId: "Optional[str]"
    """`DocumentType` node's systemId."""
    frameId: "Optional[FrameId]"
    """Frame ID for frame owner elements and also for the document node."""
    contentDocumentIndex: "Optional[int]"
    """The index of a frame owner element's content document in the `domNodes` array returned by
`getSnapshot`, if any."""
    pseudoType: "Optional[PseudoType]"
    """Type of a pseudo element node."""
    shadowRootType: "Optional[ShadowRootType]"
    """Shadow root type."""
    isClickable: "Optional[bool]"
    """Whether this DOM node responds to mouse clicks. This includes nodes that have had click
event listeners attached via JavaScript as well as anchor tags that naturally navigate when
clicked."""
    eventListeners: "Optional[List[EventListener]]"
    """Details of the node's event listeners, if any."""
    currentSourceURL: "Optional[str]"
    """The selected url for nodes with a srcset attribute."""
    originURL: "Optional[str]"
    """The url of the script (if any) that generates this node."""
    scrollOffsetX: "Optional[float]"
    """Scroll offsets, set when this node is a Document."""
    scrollOffsetY: "Optional[float]"



"""Details of post layout rendered text positions. The exact layout should not be regarded as
stable and may change between versions."""
class InlineTextBox(TypedDict):
    boundingBox: "Rect"
    """The bounding box in document coordinates. Note that scroll offset of the document is ignored."""
    startCharacterIndex: "int"
    """The starting index in characters, for this post layout textbox substring. Characters that
would be represented as a surrogate pair in UTF-16 have length 2."""
    numCharacters: "int"
    """The number of characters in this post layout textbox substring. Characters that would be
represented as a surrogate pair in UTF-16 have length 2."""



"""Details of an element in the DOM tree with a LayoutObject."""
class LayoutTreeNode(TypedDict):
    domNodeIndex: "int"
    """The index of the related DOM node in the `domNodes` array returned by `getSnapshot`."""
    boundingBox: "Rect"
    """The bounding box in document coordinates. Note that scroll offset of the document is ignored."""
    layoutText: "Optional[str]"
    """Contents of the LayoutText, if any."""
    inlineTextNodes: "Optional[List[InlineTextBox]]"
    """The post-layout inline text nodes, if any."""
    styleIndex: "Optional[int]"
    """Index into the `computedStyles` array returned by `getSnapshot`."""
    paintOrder: "Optional[int]"
    """Global paint order index, which is determined by the stacking order of the nodes. Nodes
that are painted together will have the same index. Only provided if includePaintOrder in
getSnapshot was true."""
    isStackingContext: "Optional[bool]"
    """Set to true to indicate the element begins a new stacking context."""



"""A subset of the full ComputedStyle as defined by the request whitelist."""
class ComputedStyle(TypedDict):
    properties: "List[NameValue]"
    """Name/value pairs of computed style properties."""



"""A name/value pair."""
class NameValue(TypedDict):
    name: "str"
    """Attribute/property name."""
    value: "str"
    """Attribute/property value."""



"""Index of the string in the strings table."""
StringIndex = int



"""Index of the string in the strings table."""
ArrayOfStrings = List[StringIndex]



"""Data that is only present on rare nodes."""
class RareStringData(TypedDict):
    index: "List[int]"
    value: "List[StringIndex]"



class RareBooleanData(TypedDict):
    index: "List[int]"



class RareIntegerData(TypedDict):
    index: "List[int]"
    value: "List[int]"



Rectangle = List[float]



"""Document snapshot."""
class DocumentSnapshot(TypedDict):
    documentURL: "StringIndex"
    """Document URL that `Document` or `FrameOwner` node points to."""
    title: "StringIndex"
    """Document title."""
    baseURL: "StringIndex"
    """Base URL that `Document` or `FrameOwner` node uses for URL completion."""
    contentLanguage: "StringIndex"
    """Contains the document's content language."""
    encodingName: "StringIndex"
    """Contains the document's character set encoding."""
    publicId: "StringIndex"
    """`DocumentType` node's publicId."""
    systemId: "StringIndex"
    """`DocumentType` node's systemId."""
    frameId: "StringIndex"
    """Frame ID for frame owner elements and also for the document node."""
    nodes: "NodeTreeSnapshot"
    """A table with dom nodes."""
    layout: "LayoutTreeSnapshot"
    """The nodes in the layout tree."""
    textBoxes: "TextBoxSnapshot"
    """The post-layout inline text nodes."""
    scrollOffsetX: "Optional[float]"
    """Horizontal scroll offset."""
    scrollOffsetY: "Optional[float]"
    """Vertical scroll offset."""
    contentWidth: "Optional[float]"
    """Document content width."""
    contentHeight: "Optional[float]"
    """Document content height."""



"""Table containing nodes."""
class NodeTreeSnapshot(TypedDict, total=False):
    parentIndex: "List[int]"
    """Parent node index."""
    nodeType: "List[int]"
    """`Node`'s nodeType."""
    shadowRootType: "RareStringData"
    """Type of the shadow root the `Node` is in. String values are equal to the `ShadowRootType` enum."""
    nodeName: "List[StringIndex]"
    """`Node`'s nodeName."""
    nodeValue: "List[StringIndex]"
    """`Node`'s nodeValue."""
    backendNodeId: "List[BackendNodeId]"
    """`Node`'s id, corresponds to DOM.Node.backendNodeId."""
    attributes: "List[ArrayOfStrings]"
    """Attributes of an `Element` node. Flatten name, value pairs."""
    textValue: "RareStringData"
    """Only set for textarea elements, contains the text value."""
    inputValue: "RareStringData"
    """Only set for input elements, contains the input's associated text value."""
    inputChecked: "RareBooleanData"
    """Only set for radio and checkbox input elements, indicates if the element has been checked"""
    optionSelected: "RareBooleanData"
    """Only set for option elements, indicates if the element has been selected"""
    contentDocumentIndex: "RareIntegerData"
    """The index of the document in the list of the snapshot documents."""
    pseudoType: "RareStringData"
    """Type of a pseudo element node."""
    pseudoIdentifier: "RareStringData"
    """Pseudo element identifier for this node. Only present if there is a
valid pseudoType."""
    isClickable: "RareBooleanData"
    """Whether this DOM node responds to mouse clicks. This includes nodes that have had click
event listeners attached via JavaScript as well as anchor tags that naturally navigate when
clicked."""
    currentSourceURL: "RareStringData"
    """The selected url for nodes with a srcset attribute."""
    originURL: "RareStringData"
    """The url of the script (if any) that generates this node."""



"""Table of details of an element in the DOM tree with a LayoutObject."""
class LayoutTreeSnapshot(TypedDict):
    nodeIndex: "List[int]"
    """Index of the corresponding node in the `NodeTreeSnapshot` array returned by `captureSnapshot`."""
    styles: "List[ArrayOfStrings]"
    """Array of indexes specifying computed style strings, filtered according to the `computedStyles` parameter passed to `captureSnapshot`."""
    bounds: "List[Rectangle]"
    """The absolute position bounding box."""
    text: "List[StringIndex]"
    """Contents of the LayoutText, if any."""
    stackingContexts: "RareBooleanData"
    """Stacking context information."""
    paintOrders: "Optional[List[int]]"
    """Global paint order index, which is determined by the stacking order of the nodes. Nodes
that are painted together will have the same index. Only provided if includePaintOrder in
captureSnapshot was true."""
    offsetRects: "Optional[List[Rectangle]]"
    """The offset rect of nodes. Only available when includeDOMRects is set to true"""
    scrollRects: "Optional[List[Rectangle]]"
    """The scroll rect of nodes. Only available when includeDOMRects is set to true"""
    clientRects: "Optional[List[Rectangle]]"
    """The client rect of nodes. Only available when includeDOMRects is set to true"""
    blendedBackgroundColors: "Optional[List[StringIndex]]"
    """The list of background colors that are blended with colors of overlapping elements."""
    textColorOpacities: "Optional[List[float]]"
    """The list of computed text opacities."""



"""Table of details of the post layout rendered text positions. The exact layout should not be regarded as
stable and may change between versions."""
class TextBoxSnapshot(TypedDict):
    layoutIndex: "List[int]"
    """Index of the layout tree node that owns this box collection."""
    bounds: "List[Rectangle]"
    """The absolute position bounding box."""
    start: "List[int]"
    """The starting index in characters, for this post layout textbox substring. Characters that
would be represented as a surrogate pair in UTF-16 have length 2."""
    length: "List[int]"
    """The number of characters in this post layout textbox substring. Characters that would be
represented as a surrogate pair in UTF-16 have length 2."""
