# This file is auto-generated by the CDP protocol generator.
# Do not edit this file manually as your changes will be overwritten.
# Generated from Chrome DevTools Protocol specifications.

"""CDP Emulation Domain Types"""

from enum import Enum
from typing import List, Optional
from typing_extensions import TypedDict

class SafeAreaInsets(TypedDict, total=False):
    top: "int"
    """Overrides safe-area-inset-top."""
    topMax: "int"
    """Overrides safe-area-max-inset-top."""
    left: "int"
    """Overrides safe-area-inset-left."""
    leftMax: "int"
    """Overrides safe-area-max-inset-left."""
    bottom: "int"
    """Overrides safe-area-inset-bottom."""
    bottomMax: "int"
    """Overrides safe-area-max-inset-bottom."""
    right: "int"
    """Overrides safe-area-inset-right."""
    rightMax: "int"
    """Overrides safe-area-max-inset-right."""



"""Screen orientation."""
class ScreenOrientation(TypedDict):
    type: "str"
    """Orientation type."""
    angle: "int"
    """Orientation angle."""



class DisplayFeature(TypedDict):
    orientation: "str"
    """Orientation of a display feature in relation to screen"""
    offset: "int"
    """The offset from the screen origin in either the x (for vertical
orientation) or y (for horizontal orientation) direction."""
    maskLength: "int"
    """A display feature may mask content such that it is not physically
displayed - this length along with the offset describes this area.
A display feature that only splits content will have a 0 mask_length."""



class DevicePosture(TypedDict):
    type: "str"
    """Current posture of the device"""



class MediaFeature(TypedDict):
    name: "str"
    value: "str"



"""advance: If the scheduler runs out of immediate work, the virtual time base may fast forward to
allow the next delayed task (if any) to run; pause: The virtual time base may not advance;
pauseIfNetworkFetchesPending: The virtual time base may not advance if there are any pending
resource fetches."""
class VirtualTimePolicy(Enum):
    ADVANCE = "advance"
    PAUSE = "pause"
    PAUSEIFNETWORKFETCHESPENDING = "pauseIfNetworkFetchesPending"



"""Used to specify User Agent Client Hints to emulate. See https://wicg.github.io/ua-client-hints"""
class UserAgentBrandVersion(TypedDict):
    brand: "str"
    version: "str"



"""Used to specify User Agent Client Hints to emulate. See https://wicg.github.io/ua-client-hints
Missing optional values will be filled in by the target with what it would normally use."""
class UserAgentMetadata(TypedDict):
    brands: "Optional[List[UserAgentBrandVersion]]"
    """Brands appearing in Sec-CH-UA."""
    fullVersionList: "Optional[List[UserAgentBrandVersion]]"
    """Brands appearing in Sec-CH-UA-Full-Version-List."""
    fullVersion: "Optional[str]"
    platform: "str"
    platformVersion: "str"
    architecture: "str"
    model: "str"
    mobile: "bool"
    bitness: "Optional[str]"
    wow64: "Optional[bool]"
    formFactors: "Optional[List[str]]"
    """Used to specify User Agent form-factor values.
See https://wicg.github.io/ua-client-hints/#sec-ch-ua-form-factors"""



"""Used to specify sensor types to emulate.
See https://w3c.github.io/sensors/#automation for more information."""
class SensorType(Enum):
    ABSOLUTE_ORIENTATION = "absolute-orientation"
    ACCELEROMETER = "accelerometer"
    AMBIENT_LIGHT = "ambient-light"
    GRAVITY = "gravity"
    GYROSCOPE = "gyroscope"
    LINEAR_ACCELERATION = "linear-acceleration"
    MAGNETOMETER = "magnetometer"
    RELATIVE_ORIENTATION = "relative-orientation"



class SensorMetadata(TypedDict, total=False):
    available: "bool"
    minimumFrequency: "float"
    maximumFrequency: "float"



class SensorReadingSingle(TypedDict):
    value: "float"



class SensorReadingXYZ(TypedDict):
    x: "float"
    y: "float"
    z: "float"



class SensorReadingQuaternion(TypedDict):
    x: "float"
    y: "float"
    z: "float"
    w: "float"



class SensorReading(TypedDict, total=False):
    single: "SensorReadingSingle"
    xyz: "SensorReadingXYZ"
    quaternion: "SensorReadingQuaternion"



class PressureSource(Enum):
    CPU = "cpu"



class PressureState(Enum):
    NOMINAL = "nominal"
    FAIR = "fair"
    SERIOUS = "serious"
    CRITICAL = "critical"



class PressureMetadata(TypedDict, total=False):
    available: "bool"



"""Enum of image types that can be disabled."""
class DisabledImageType(Enum):
    AVIF = "avif"
    WEBP = "webp"
