# This file is auto-generated by the CDP protocol generator.
# Do not edit this file manually as your changes will be overwritten.
# Generated from Chrome DevTools Protocol specifications.

"""CDP HeapProfiler Domain Types"""

from typing import List
from typing_extensions import TypedDict

from typing import TYPE_CHECKING

if TYPE_CHECKING:
    from ..runtime.types import CallFrame

"""Heap snapshot object id."""
HeapSnapshotObjectId = str



"""Sampling Heap Profile node. Holds callsite information, allocation statistics and child nodes."""
class SamplingHeapProfileNode(TypedDict):
    callFrame: "CallFrame"
    """Function location."""
    selfSize: "float"
    """Allocations size in bytes for the node excluding children."""
    id: "int"
    """Node id. Ids are unique across all profiles collected between startSampling and stopSampling."""
    children: "List[SamplingHeapProfileNode]"
    """Child nodes."""



"""A single sample from a sampling profile."""
class SamplingHeapProfileSample(TypedDict):
    size: "float"
    """Allocation size in bytes attributed to the sample."""
    nodeId: "int"
    """Id of the corresponding profile tree node."""
    ordinal: "float"
    """Time-ordered sample ordinal number. It is unique across all profiles retrieved
between startSampling and stopSampling."""



"""Sampling profile."""
class SamplingHeapProfile(TypedDict):
    head: "SamplingHeapProfileNode"
    samples: "List[SamplingHeapProfileSample]"
