# This file is auto-generated by the CDP protocol generator.
# Do not edit this file manually as your changes will be overwritten.
# Generated from Chrome DevTools Protocol specifications.

"""CDP IndexedDB Domain Types"""

from typing import List, Optional
from typing_extensions import TypedDict

from typing import TYPE_CHECKING

if TYPE_CHECKING:
    from ..runtime.types import RemoteObject

"""Database with an array of object stores."""
class DatabaseWithObjectStores(TypedDict):
    name: "str"
    """Database name."""
    version: "float"
    """Database version (type is not 'integer', as the standard
requires the version number to be 'unsigned long long')"""
    objectStores: "List[ObjectStore]"
    """Object stores in this database."""



"""Object store."""
class ObjectStore(TypedDict):
    name: "str"
    """Object store name."""
    keyPath: "KeyPath"
    """Object store key path."""
    autoIncrement: "bool"
    """If true, object store has auto increment flag set."""
    indexes: "List[ObjectStoreIndex]"
    """Indexes in this object store."""



"""Object store index."""
class ObjectStoreIndex(TypedDict):
    name: "str"
    """Index name."""
    keyPath: "KeyPath"
    """Index key path."""
    unique: "bool"
    """If true, index is unique."""
    multiEntry: "bool"
    """If true, index allows multiple entries for a key."""



"""Key."""
class Key(TypedDict):
    type: "str"
    """Key type."""
    number: "Optional[float]"
    """Number value."""
    string: "Optional[str]"
    """String value."""
    date: "Optional[float]"
    """Date value."""
    array: "Optional[List[Key]]"
    """Array value."""



"""Key range."""
class KeyRange(TypedDict):
    lower: "Optional[Key]"
    """Lower bound."""
    upper: "Optional[Key]"
    """Upper bound."""
    lowerOpen: "bool"
    """If true lower bound is open."""
    upperOpen: "bool"
    """If true upper bound is open."""



"""Data entry."""
class DataEntry(TypedDict):
    key: "RemoteObject"
    """Key object."""
    primaryKey: "RemoteObject"
    """Primary key object."""
    value: "RemoteObject"
    """Value object."""



"""Key path."""
class KeyPath(TypedDict):
    type: "str"
    """Key path type."""
    string: "Optional[str]"
    """String value."""
    array: "Optional[List[str]]"
    """Array value."""
