# This file is auto-generated by the CDP protocol generator.
# Do not edit this file manually as your changes will be overwritten.
# Generated from Chrome DevTools Protocol specifications.

"""CDP Input Domain Types"""

from enum import Enum
from typing import List, Optional
from typing_extensions import TypedDict

class TouchPoint(TypedDict):
    x: "float"
    """X coordinate of the event relative to the main frame's viewport in CSS pixels."""
    y: "float"
    """Y coordinate of the event relative to the main frame's viewport in CSS pixels. 0 refers to
the top of the viewport and Y increases as it proceeds towards the bottom of the viewport."""
    radiusX: "Optional[float]"
    """X radius of the touch area (default: 1.0)."""
    radiusY: "Optional[float]"
    """Y radius of the touch area (default: 1.0)."""
    rotationAngle: "Optional[float]"
    """Rotation angle (default: 0.0)."""
    force: "Optional[float]"
    """Force (default: 1.0)."""
    tangentialPressure: "Optional[float]"
    """The normalized tangential pressure, which has a range of [-1,1] (default: 0)."""
    tiltX: "Optional[float]"
    """The plane angle between the Y-Z plane and the plane containing both the stylus axis and the Y axis, in degrees of the range [-90,90], a positive tiltX is to the right (default: 0)"""
    tiltY: "Optional[float]"
    """The plane angle between the X-Z plane and the plane containing both the stylus axis and the X axis, in degrees of the range [-90,90], a positive tiltY is towards the user (default: 0)."""
    twist: "Optional[int]"
    """The clockwise rotation of a pen stylus around its own major axis, in degrees in the range [0,359] (default: 0)."""
    id: "Optional[float]"
    """Identifier used to track touch sources between events, must be unique within an event."""



class GestureSourceType(Enum):
    DEFAULT = "default"
    TOUCH = "touch"
    MOUSE = "mouse"



class MouseButton(Enum):
    NONE = "none"
    LEFT = "left"
    MIDDLE = "middle"
    RIGHT = "right"
    BACK = "back"
    FORWARD = "forward"



"""UTC time in seconds, counted from January 1, 1970."""
TimeSinceEpoch = float



class DragDataItem(TypedDict):
    mimeType: "str"
    """Mime type of the dragged data."""
    data: "str"
    """Depending of the value of `mimeType`, it contains the dragged link,
text, HTML markup or any other data."""
    title: "Optional[str]"
    """Title associated with a link. Only valid when `mimeType` == \"text/uri-list\"."""
    baseURL: "Optional[str]"
    """Stores the base URL for the contained markup. Only valid when `mimeType`
== \"text/html\"."""



class DragData(TypedDict):
    items: "List[DragDataItem]"
    files: "Optional[List[str]]"
    """List of filenames that should be included when dropping"""
    dragOperationsMask: "int"
    """Bit field representing allowed drag operations. Copy = 1, Link = 2, Move = 16"""
