# This file is auto-generated by the CDP protocol generator.
# Do not edit this file manually as your changes will be overwritten.
# Generated from Chrome DevTools Protocol specifications.

"""CDP LayerTree Domain Types"""

from typing import List, Optional
from typing_extensions import TypedDict

from typing import TYPE_CHECKING

if TYPE_CHECKING:
    from ..dom.types import BackendNodeId
    from ..dom.types import Rect

"""Unique Layer identifier."""
LayerId = str



"""Unique snapshot identifier."""
SnapshotId = str



"""Rectangle where scrolling happens on the main thread."""
class ScrollRect(TypedDict):
    rect: "Rect"
    """Rectangle itself."""
    type: "str"
    """Reason for rectangle to force scrolling on the main thread"""



"""Sticky position constraints."""
class StickyPositionConstraint(TypedDict):
    stickyBoxRect: "Rect"
    """Layout rectangle of the sticky element before being shifted"""
    containingBlockRect: "Rect"
    """Layout rectangle of the containing block of the sticky element"""
    nearestLayerShiftingStickyBox: "Optional[LayerId]"
    """The nearest sticky layer that shifts the sticky box"""
    nearestLayerShiftingContainingBlock: "Optional[LayerId]"
    """The nearest sticky layer that shifts the containing block"""



"""Serialized fragment of layer picture along with its offset within the layer."""
class PictureTile(TypedDict):
    x: "float"
    """Offset from owning layer left boundary"""
    y: "float"
    """Offset from owning layer top boundary"""
    picture: "str"
    """Base64-encoded snapshot data. (Encoded as a base64 string when passed over JSON)"""



"""Information about a compositing layer."""
class Layer(TypedDict):
    layerId: "LayerId"
    """The unique id for this layer."""
    parentLayerId: "Optional[LayerId]"
    """The id of parent (not present for root)."""
    backendNodeId: "Optional[BackendNodeId]"
    """The backend id for the node associated with this layer."""
    offsetX: "float"
    """Offset from parent layer, X coordinate."""
    offsetY: "float"
    """Offset from parent layer, Y coordinate."""
    width: "float"
    """Layer width."""
    height: "float"
    """Layer height."""
    transform: "Optional[List[float]]"
    """Transformation matrix for layer, default is identity matrix"""
    anchorX: "Optional[float]"
    """Transform anchor point X, absent if no transform specified"""
    anchorY: "Optional[float]"
    """Transform anchor point Y, absent if no transform specified"""
    anchorZ: "Optional[float]"
    """Transform anchor point Z, absent if no transform specified"""
    paintCount: "int"
    """Indicates how many time this layer has painted."""
    drawsContent: "bool"
    """Indicates whether this layer hosts any content, rather than being used for
transform/scrolling purposes only."""
    invisible: "Optional[bool]"
    """Set if layer is not visible."""
    scrollRects: "Optional[List[ScrollRect]]"
    """Rectangles scrolling on main thread only."""
    stickyPositionConstraint: "Optional[StickyPositionConstraint]"
    """Sticky position constraint information"""



"""Array of timings, one per paint step."""
PaintProfile = List[float]
