# This file is auto-generated by the CDP protocol generator.
# Do not edit this file manually as your changes will be overwritten.
# Generated from Chrome DevTools Protocol specifications.

"""CDP ServiceWorker Domain Types"""

from enum import Enum
from typing import List, Optional
from typing_extensions import TypedDict

from typing import TYPE_CHECKING

if TYPE_CHECKING:
    from ..target.types import TargetID

RegistrationID = str



"""ServiceWorker registration."""
class ServiceWorkerRegistration(TypedDict):
    registrationId: "RegistrationID"
    scopeURL: "str"
    isDeleted: "bool"



class ServiceWorkerVersionRunningStatus(Enum):
    STOPPED = "stopped"
    STARTING = "starting"
    RUNNING = "running"
    STOPPING = "stopping"



class ServiceWorkerVersionStatus(Enum):
    NEW = "new"
    INSTALLING = "installing"
    INSTALLED = "installed"
    ACTIVATING = "activating"
    ACTIVATED = "activated"
    REDUNDANT = "redundant"



"""ServiceWorker version."""
class ServiceWorkerVersion(TypedDict):
    versionId: "str"
    registrationId: "RegistrationID"
    scriptURL: "str"
    runningStatus: "ServiceWorkerVersionRunningStatus"
    status: "ServiceWorkerVersionStatus"
    scriptLastModified: "Optional[float]"
    """The Last-Modified header value of the main script."""
    scriptResponseTime: "Optional[float]"
    """The time at which the response headers of the main script were received from the server.
For cached script it is the last time the cache entry was validated."""
    controlledClients: "Optional[List[TargetID]]"
    targetId: "Optional[TargetID]"
    routerRules: "Optional[str]"



"""ServiceWorker error message."""
class ServiceWorkerErrorMessage(TypedDict):
    errorMessage: "str"
    registrationId: "RegistrationID"
    versionId: "str"
    sourceURL: "str"
    lineNumber: "int"
    columnNumber: "int"
