# This file is auto-generated by the CDP protocol generator.
# Do not edit this file manually as your changes will be overwritten.
# Generated from Chrome DevTools Protocol specifications.

"""CDP WebAudio Domain Types"""

from enum import Enum
from typing import Optional
from typing_extensions import TypedDict

"""An unique ID for a graph object (AudioContext, AudioNode, AudioParam) in Web Audio API"""
GraphObjectId = str



"""Enum of BaseAudioContext types"""
class ContextType(Enum):
    REALTIME = "realtime"
    OFFLINE = "offline"



"""Enum of AudioContextState from the spec"""
class ContextState(Enum):
    SUSPENDED = "suspended"
    RUNNING = "running"
    CLOSED = "closed"
    INTERRUPTED = "interrupted"



"""Enum of AudioNode types"""
NodeType = str



"""Enum of AudioNode::ChannelCountMode from the spec"""
class ChannelCountMode(Enum):
    CLAMPED_MAX = "clamped-max"
    EXPLICIT = "explicit"
    MAX = "max"



"""Enum of AudioNode::ChannelInterpretation from the spec"""
class ChannelInterpretation(Enum):
    DISCRETE = "discrete"
    SPEAKERS = "speakers"



"""Enum of AudioParam types"""
ParamType = str



"""Enum of AudioParam::AutomationRate from the spec"""
class AutomationRate(Enum):
    A_RATE = "a-rate"
    K_RATE = "k-rate"



"""Fields in AudioContext that change in real-time."""
class ContextRealtimeData(TypedDict):
    currentTime: "float"
    """The current context time in second in BaseAudioContext."""
    renderCapacity: "float"
    """The time spent on rendering graph divided by render quantum duration,
and multiplied by 100. 100 means the audio renderer reached the full
capacity and glitch may occur."""
    callbackIntervalMean: "float"
    """A running mean of callback interval."""
    callbackIntervalVariance: "float"
    """A running variance of callback interval."""



"""Protocol object for BaseAudioContext"""
class BaseAudioContext(TypedDict):
    contextId: "GraphObjectId"
    contextType: "ContextType"
    contextState: "ContextState"
    realtimeData: "Optional[ContextRealtimeData]"
    callbackBufferSize: "float"
    """Platform-dependent callback buffer size."""
    maxOutputChannelCount: "float"
    """Number of output channels supported by audio hardware in use."""
    sampleRate: "float"
    """Context sample rate."""



"""Protocol object for AudioListener"""
class AudioListener(TypedDict):
    listenerId: "GraphObjectId"
    contextId: "GraphObjectId"



"""Protocol object for AudioNode"""
class AudioNode(TypedDict):
    nodeId: "GraphObjectId"
    contextId: "GraphObjectId"
    nodeType: "NodeType"
    numberOfInputs: "float"
    numberOfOutputs: "float"
    channelCount: "float"
    channelCountMode: "ChannelCountMode"
    channelInterpretation: "ChannelInterpretation"



"""Protocol object for AudioParam"""
class AudioParam(TypedDict):
    paramId: "GraphObjectId"
    nodeId: "GraphObjectId"
    contextId: "GraphObjectId"
    paramType: "ParamType"
    rate: "AutomationRate"
    defaultValue: "float"
    minValue: "float"
    maxValue: "float"
